/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rasdaman.testconnectionrasj;

import org.odmg.Database;
import org.odmg.ODMGException;
import org.odmg.Transaction;
import rasj.RasImplementation;

/**
 *
 * @author dimitar
 */
public class TestConnection {
    
    private static String server = "localhost";
    private static String port = "7001";
    private static String databaseName = "RASBASE";
    private static String user = "rasadmin";
    private static String password = "rasadmin";

    public static void main(String[] args) {
        System.out.println("----------------------------------------------------");
        System.out.println("Starting test");
        long startTime = 0;
        long totalStartTime = System.nanoTime();
        Database database = null;
        try {
            startTime = System.nanoTime();
            RasImplementation app = new RasImplementation("http://" + server + ":" + port);
            
            System.out.println("Constructing RasImplementation: " + 
                    ((System.nanoTime() - startTime)/1000000) + " ms");
            startTime = System.nanoTime();
            
            app.setUserIdentification(user, password);
            
            System.out.println("Setting user identification: " + 
                    ((System.nanoTime() - startTime)/1000000) + " ms");
            startTime = System.nanoTime();
        
            database = app.newDatabase();
            
            System.out.println("Creating Database: " + 
                    ((System.nanoTime() - startTime)/1000000) + " ms");
            startTime = System.nanoTime();
            
            database.open(databaseName, Database.OPEN_READ_WRITE);
            
            System.out.println("Opening database: " + 
                    ((System.nanoTime() - startTime)/1000000) + " ms");
           
            for (int i = 0; i < 10; i++)
            {
                System.out.println("");
                startTime = System.nanoTime();
                Transaction transaction = app.newTransaction();

                System.out.println("Creating Transaction " + i + ": " + 
                        ((System.nanoTime() - startTime)/1000000) + " ms");
                startTime = System.nanoTime();

                transaction.begin();

                System.out.println("Begin Transaction " + i + ": " + 
                        ((System.nanoTime() - startTime)/1000000) + " ms");
                startTime = System.nanoTime();

                // do some stuff here...
                transaction.commit();

                System.out.println("Commit Transaction " + i + ": " + 
                        ((System.nanoTime() - startTime)/1000000) + " ms");
            }
            

        } catch (ODMGException e) {
            e.printStackTrace();
        } finally {
            if (database != null) {
                try {
                    database.close();
                } catch (ODMGException e) {
                    e.printStackTrace();
                }
            }
        }
        
        long estimatedTime = System.nanoTime() - totalStartTime;
        System.out.println("Total elapsed time: " + (estimatedTime/1000000) + " ms");
        System.out.println("Test finished");
        System.out.println("----------------------------------------------------");
    }

}
